<?php
/*
	phprpc ver 0.7.12  2020/04/26
	Copyright (c) 2002-2020 Hideya Tanaka
*/

	require("phpsoap.inc");

	function rpc_call($func,$param,$uri,$domain,$path,$host,$port=80,$soapaction=""){
		//饤¦SOAP֥Ȥκ
		$soap = new PHPSOAP(0);
		//٥ץΡɤκ
		$enve = $soap->make_Envelope();
		//٥ץإåΡɤκ
		$head = $soap->make_Header();
		//٥ץܥǥΡɤκ
		$body = $soap->make_Body();

		//functionΡɤɲ
		$id = $soap->add_node($body,"$func","xmlns:namesp1=\"$uri\"","namesp1");
		$num = count($param);
		for($i=0;$i<$num;$i++){
			$value = $param[$i];
			$j = $i+1;
			//Ρɤɲ
			$id2 = $soap->add_node($id,"param_$j","","");
				//ΡɤͤΥå
			$soap->set_value($id2,"$value");
			}
		//XMLʸ˥󥳡
		$soap->encode($enve,0);
/*	
		//åγǧ
		$msg2 = ereg_replace("\t","    ",$soap->mess);
		$msg2 = ereg_replace(">",">\n",$msg2);
		print "å<br>";
		print "<pre>" . htmlspecialchars($msg2) . "</pre>"; 
*/	
		//å
		$fp = $soap->send_Message($domain,$path,$host,$port,$soapaction);
	
		//åμ
		$msg = $soap->get_message($fp);
		//SOAP֥Ȥγ
		unset($soap);
		
		return $msg;
	}
	
	function rpc_call_type($func,$param,$uri,$domain,$path,$host,$port=80,$soapaction=""){
		//饤¦SOAP֥Ȥκ
		$soap = new PHPSOAP(0);
		//٥ץΡɤκ
		$enve = $soap->make_Envelope();
		//٥ץإåΡɤκ
		$head = $soap->make_Header();
		//٥ץܥǥΡɤκ
		$body = $soap->make_Body();

		//functionΡɤɲ
		$id = $soap->add_node($body,"$func","xmlns:namesp1=\"$uri\" xmlns:xsi=\"http://www.w3.org/1999/XMLSchema-instance\" xmlns:xsd=\"http://www.w3.org/1999/XMLSchema\" xmlns:SOAP-ENC=\"http://schemas.xmlsoap.org/soap/encoding/\"","namesp1");
		$num = count($param["value"]);
		for($i=0;$i<$num;$i++){
			$value = $param["value"][$i];
			$name = $param["name"][$i];
			$type = $param["type"][$i];
			$j = $i+1;
			if($type == "SOAP-ENC:base64"){
				$id2 = $soap->add_node($id,"$name","xsi:type=\"SOAP-ENC:base64\"","");
			}else{
				//Ρɤɲ
				$id2 = $soap->add_node($id,"$name","xsi:type=\"xsd:$type\"","");
			}
			//ΡɤͤΥå
			$soap->set_value($id2,"$value");
		}
		//XMLʸ˥󥳡
		$soap->encode($enve,0);
/*	
		//åγǧ
		$msg2 = ereg_replace("\t","    ",$soap->mess);
		print "å<br>";
		$msg2 = ereg_replace(">",">\n",$msg2);
		print "<pre>" . htmlspecialchars($msg2) . "</pre>"; 
*/
		//å
		$fp = $soap->send_Message($domain,$path,$host,$port,$soapaction);
	
		//åμ
		$msg = $soap->get_message($fp);
		//SOAP֥Ȥγ
		unset($soap);
	
		return $msg;
	}

	function rpc_result($msg){
/*
		//åγǧ
		print "ֿå<br>";
		$msg2 = ereg_replace("\t","    ",$msg);
		$msg2 = ereg_replace(">",">\n",$msg2);
		print "<pre>". htmlspecialchars($msg2) ."</pre>";
*/
		//饤¦SOAP֥Ȥκ
		$soap = new PHPSOAP(0);
		//٥ץܥǥidμ
		$body = $soap->get_body($msg);
		//bodyλҥΡƤ
		$node_array = $soap->get_childs($body);
		//${function}ResponseΡɤidμ
		$id = $node_array[0];
		//idλҥΡƤ
		$node_array = $soap->get_childs($id);
		//ǽΥΡɤidμ
		$id = $node_array[0];
		//nameΡɤͤμ
		$result = $soap->get_value($id);
		//nameΡɤtypeμ
		$type = $soap->get_attrib($id,"xsi:type");

		//SOAP֥Ȥγ
		unset($soap);
		if($type == "SOAP-ENC:base64"){
			$result = base64_decode($result);
		}
		return $result;
	}

	function rpc_result_array($msg){
/*
		//åγǧ
		print "ֿå<br>";
		$msg2 = ereg_replace("\t","    ",$msg);
		$msg2 = ereg_replace(">",">\n",$msg2);
		print "<pre>". htmlspecialchars($msg2) ."</pre>";
*/	
		//饤¦SOAP֥Ȥκ
		$soap = new PHPSOAP(0);
		//٥ץܥǥidμ
		$body = $soap->get_body($msg);
		//bodyλҥΡƤ
		$node_array = $soap->get_childs($body);
		//${function}ResponseΡɤidμ
		$id = $node_array[0];
		//idλҥΡƤ
		$node_array = $soap->get_childs($id);
	
		$num = count($node_array);
		
		$rarray = array();

		for($i=0;$i<$num;$i++){
	
			//Ρɤidμ
			$id = $node_array[$i];
			//Ρɤ̾μ
			$name = $soap->get_node_name($id);
			//Ρɤͤμ
			$value = $soap->get_value($id);
			//Ρɤtypeμ
			$type = $soap->get_attrib($id,"xsi:type");

			if($type == "SOAP-ENC:base64"){
				$value = base64_decode($value);
			}
			//ͤ򥻥å
			$rarray["name"][$i] = $name;
			$rarray["type"][$i] = $type;
			$rarray["value"][$i] = $value;
		}
		//SOAP֥Ȥγ
		unset($soap);

		return $rarray;
	}

	function rpc_server($func_list,$ns,$uri){
		$error_no = 2;
		$error_msg = "";
		//С¦SOAP֥Ⱥ
		$soap = new PHPSOAP(1);
		//åμ
		$msg = $soap->saver_get_message();
/*
		$fp = fopen("sever_get_msg.txt","w");
		fwrite($fp,$msg);
		fclose($fp);
*/
		//٥ץܥǥidμ
		$body = $soap->get_body($msg);
		//ӥ̾μ
		$function = $soap->get_function($body);
		//ѥ᡼μ
		$param = $soap->get_param($body);
		//SOAP֥Ȥγ
		unset($soap);

		$num = count($func_list);

		$flg = 0;	
		for($i=0;$i<$num;$i++){
			if($function == $func_list[$i]){
				$flg = 1;
			}
		}
		if($flg==1){
			$param=$function($param);
			$error_msg = $param["error_msg"];
			$error_no = $param["error_no"];
		}
		
		//ֿ
		$soap = new PHPSOAP(1);
		if($flg == 0){
			$error_no= 2;
			$error_msg  = "Υӥͭޤfunction=" . $function;
		}		
		//顼
		if($error_msg != ""){
			if($error_no == 1){
				$soap->server_error(1,"Server error",$error_msg);
			}else{
				$soap->server_error(2,"Client error",$error_msg);
			}
		}
		$soap->response($param,$function,$ns,$uri);
		//SOAP֥Ȥγ
		unset($soap);
	}

	function rpc_server_type($func_list,$ns,$uri){
		$error_no = 2;
		$error_msg = "";
		//С¦SOAP֥Ⱥ
		$soap = new PHPSOAP(1);
		//åμ
		$msg = $soap->saver_get_message();
/*
		$fp = fopen("sever_get_msg.txt","w");
		fwrite($fp,$msg);
		fclose($fp);
*/	
		//٥ץܥǥidμ
		$body = $soap->get_body($msg);
		//ӥ̾μ
		$function = $soap->get_function($body);
		//ѥ᡼μ
		$param = $soap->get_param($body);
		//base64ʸ󥳡ɤμ
		$enc = $soap->get_enc();
		//SOAP֥Ȥγ
		unset($soap);

		$num = count($func_list);

		$flg = 0;	
		for($i=0;$i<$num;$i++){
			if($function == $func_list[$i]){
				$flg = 1;
			}
		}
		if($flg==1){
			$param=$function($param);
			if(isset($param["error_msg"])){
				$error_msg = $param["error_msg"];
			}else{
				$error_msg = "";
			}
			if(isset($param["error_no"])){
				$error_no = $param["error_no"];
			}else{
				$error_no = 0;
			}
		}
		//ֿ
		$soap = new PHPSOAP(1);
		//base64ʸ󥳡ɤΥå
		$soap->set_enc($enc);
		if($flg == 0){
			$error_no= 2;
			$error_msg  = "Υӥͭޤfunction=" . $function;
		}		
		//顼
		if($error_msg != ""){
			if($error_no == 1){
				$soap->server_error(1,"Server error",$error_msg);
			}else{
				$soap->server_error(2,"Client error",$error_msg);
			}
		}
		$soap->response_type($param,$function,$ns,$uri);
		//SOAP֥Ȥγ
		unset($soap);
	}

?>
