<?php
	if(phpversion()>="5.1.0"){
		date_default_timezone_set('Asia/Tokyo');
	}

class PHPSOAP{
/*
	phpsoap ver 0.7.12 2020/04/26
	Copyright (c) 2002-2020 Hideya Tanaka

		Nodeξ
		$this->node{$id]["name"] = "/";					node̾
		$this->node{$id]["parent"] = 0;					nodeid
		$this->node[$id]["level"] = 0;					nodeγ
		$this->node[$id]["child"]["num"] = 0;			nodeο
		$this->node[$id]["child"][0] = 0;				nodeid
		$this->node[$id]["attrib"]["num"] = 0;			node°ο
		$this->node[$id]["attrib"]["name"][0] = "";		node°̾
		$this->node[$id]["attrib"]["value"][0] = "";	node°
		$this->node[$id]["text"]=0;						Textnodeξ磱
		$this->node[$id]["NS"] = "";					͡ॹڡ

		textnodeξ
		$this->node{$id]["name"] = "0text";				node̾
		$this->node{$id]["parent"] = 0;					nodeid
		$this->node[$id]["level"] = 0;					nodeγ
		$this->node[$id]["value"] = "";					node
		$this->node[$id]["child"]["num"] = 0;			nodeο
		$this->node[$id]["text"]=1;						Textnodeξ磱

		$this->uri[$ns]="";								͡ॹڡURI
		$this->ns_default[$index][1] = ""				ǥեȤΥ͡ॹڡURI
		$this->ns_default[$index][2] = ""				ǥեȤΥ͡ॹڡ򥻥åȤnodeid

		̤ΰ̡Ϣߤ
		["name"] = [1];
		["parent"] = [2];
		["level"] = [3];
		["value"] = [4];
		["text"] = [5];
		["child"]["num"] = [6];
		["child"] = [7];
		["attrib"]["num"] = [8];
		["attrib"]["name"] = [9];
		["attrib"]["value"] = [10];
		["NS"] = [11];


*/

	var $tmp_node = array();	//	Ρ̾ΰ¸
	var $tmp_index = 0;			//	tmp_nodeΥǥå
	var $root_flg=0;			//	ɥȥ롼Ƚи
	var $dtd = "";				//	DTD֥åѰХåե
	var $dtd_block = "";		//	DTD֥åѥХåե
	var $pi = "";				//	PI֥åѰХåե
	var $pi_block = "";			//	PI֥åѥХåե
	var $xml_block = "";		//	XMLΥХåե
	var $comment = "";			//	ȥ֥åѥХåե
	var $comment_block = "";	//	ȥ֥åѥХåե
	var $dtd_flg = 0;			//	DTD֥åѥե饰DTDother
	var $pi_flg = 0;			//	PI֥åѥե饰	PIother
	var $comment_flg = 0;		//	ȥ֥åѥե饰	ȡother
	var $block_flg = 0;			//	֥åѥե饰	֥åother
	var $line_buff="";			//	֥åѥХåե
	var $line_num = 0;			//	Կ

	var $node = array();		//	node
	var $id_num = 0;			//	nodeθĿ
	var $node_level = 0;		//	nodeγ
	var $max_level = 0;			//	nodeؤκ
	var $id_tmp = -1;			//	ΡIDΥХåե
	var $text_tmp="";			//	ƥȥХåե
	var $uri = array();			//	͡ॹڡURIϢ
	var $entity = array();		//	Τ
	var $entity_name = "";		//	Τ̾
	var $entity_value = "";		//	Τ
	var $entity_flg = 0;		//	ե饰

	var $root=0;				//	SOAP롼ȥΡ
	var $mess="";				//SOAPåХåե
	var $server=0;				//С饤ȤС饤
	var $error_mode=1;			//	顼ɽɽɽ顼ؿ
	var $error_func="";			//	顼ؿ
	var $ns_default = array();	//	ǥեȤΥ͡ॹڡΥХåե
	var $nsd_index = 0;			//	ǥեȤΥ͡ॹڡΥǥå
	var $seikei = 1;			//	󥳡ɻ롡ʤ
	var $enc="UTF-8";			//	̿Υǥեʸ

	function __construct($server) {
		$this->server = $server;

		$this->entity["amp"]="&";
		$this->entity["lt"]="&lt;";
		$this->entity["gt"]="&gt;";
		$this->entity["nbsp"]="&nbsp;";
		$this->entity["quot"]="&quot;";
		$this->mess = "";
	}
			
	function server_error($err_code,$msg,$detail){
		if($this->server == 1){
			if($err_code <0 || $err_code >3) $err_code = 3;
			$faultcode = array();
			$faultcode[0] = "VersionMismatch";
			$faultcode[1] = "MustUnderstand";
			$faultcode[2] = "Client";
			$faultcode[3] = "Server";

			$msg = mb_convert_encoding($msg, "UTF-8", "EUC-JP");
			$detail = mb_convert_encoding($detail, "UTF-8", "EUC-JP");

			header("Status: 500 Internal Server Error");
			header("Content-Type: text/xml");
			print "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>";
			print "<SOAP-ENV:Envelope xmlns:SOAP-ENV=\"http://schemas.xmlsoap.org/soap/envelope/\" SOAP-ENV:encodingStyle=\"http://schemas.xmlsoap.org/soap/encoding/\">";
			print "<SOAP-ENV:Body>";
			print "<SOAP-ENV:Fault>";
			print "<faultcode>SOAP-ENV:$faultcode[$err_code]</faultcode>";
			print "<faultstring>$msg</faultstring>";
			if($detail != ""){
				print "<detail>";
				print $detail;
				print "</detail>";
			}
			print "</SOAP-ENV:Fault>";
			print "</SOAP-ENV:Body>";
			print "</SOAP-ENV:Envelope>";
		}else{
			print $msg;
		}
		exit;
	}
	function error_mode($mode,$func){
		$this->error_mode = $mode;
		$this->error_func = $func;
	}
	function soap_die($msg){
		if($this->error_mode == 1){
			if($this->server == 1){
				$this->server_error(2,"client error",$msg);
			}else{
				$msg = preg_replace("/\r/","",$msg);
				$msg = preg_replace("/>/",">\n",$msg);
				$msg = preg_replace("/<\//","\n</",$msg);
				$msg = preg_replace("/\n\n/","\n",$msg);
				$msg = preg_replace("/</","&lt;",$msg);
				$msg = preg_replace("/>/","&gt;",$msg);
//				$msg = htmlspecialchars($msg); 
				$msg = "\n顼\n" . $msg;
				$msg = nl2br($msg);
				die($msg);
			}
		}else if($this->error_mode == 2){
			$func = $this->error_func;
			$func($msg);
		}
		exit;
	}

//	*************************** DOMѴؿϡ***************************************

//	*************************** DOMѴؿλ***************************************
	function get_comment(){
		return $this->comment_block;
	}
	function get_pi(){
		return $this->pi_block;
	}
	function get_xml(){
		return $this->xml_block;
	}
	function get_dtd(){
		return $this->dtd_block;
	}
	function add_attrib($id,$attrib){
		$attrib = str_replace("\n"," ",$attrib);
		$attrib = str_replace("\r"," ",$attrib);
		$attrib = str_replace("\t"," ",$attrib);
		$attrib_quot = "";
		if($attrib != ""){
			if((!is_int($id)&&($id == ""))||($id<0)||($id>=$this->id_num)){
				die("<br>顼<br>add_attrib:°äΡֹ椬۾Ǥid=$id °=$attrib");
			}
			$len = strlen($attrib);
			$flg = 0;
			$temp = "";
			$num = $this->node[$id][8];
			for($i=0;$i<$len;$i++){
				$c = substr($attrib,$i,1);
				if($c == "="){
					if(($flg == 1)||($flg == 2)){
						$name = $temp;
						$temp = "";
						$flg = 3;
					}else if($flg == 4){
						$temp .= $c;
					}else{
						print "<br>顼<br>add_attrib:°ǡ᤬ְäˤޤid=$id °=$attrib";
						exit;
					}
				}else if(($c == "'")||($c == "\"")){
					if(($flg == 3)||($flg== 4)){
						if($flg == 3){
							$flg = 4;
							$attrib_quot = $c;
						}else{
							if($attrib_quot != $c){
								$temp .= $c;
							}else{
								for($j=0;$j<$num;$j++){
									if($this->node[$id][9][$j] == $name){
										print "<br>顼<br>add_attrib:°${name}ʣƤޤid=$id °=$attrib";
										exit;
									}
								}
								$this->node[$id][9][$num] = $name;
								$this->node[$id][10][$num] = $temp;
								//͡ॹڡν
								if(preg_match("/xmlns/i",$name)){
									$name = preg_replace("/xmlns:/i","",$name);
									if(preg_match("/xmlns/i",$name)){
										$this->ns_default[$this->nsd_index][1] = $temp;
										$this->ns_default[$this->nsd_index][2] = $id;
										$this->nsd_index++;
									}else{
										$this->uri[$name] = $temp;
									}
								}
								$num++;
								$flg = 0;
								$temp = "";
							}
						}
					}else{
						print "<br>顼<br>add_attrib:°'\"ְäˤޤid=$id °=$attrib";
						exit;
					}
				}else if($c == " "){
					if($flg == 1){
						$flg = 2;
					}
					if($flg == 4){
						$temp .= $c;
					}	
				}else{
					if($flg == 0){
						$flg = 1;
					}else if($flg == 2){
						print "<br>顼<br>add_attrib:°̾ͤδ֤ˡ᤬ޤid=$id °=$attrib";
						exit;
					}
					$temp .= $c;
				}
			}
			$this->node[$id][8] = $num;
		}
	}

	function make_node($parent,$node_name,$attrib,$ns){
		if((!is_int($parent)&&($parent == ""))||($parent<-1)||($parent>=$this->id_num)){
			die("<br>顼<br>make_node:ƥΡֹ椬۾Ǥparent=$parent node_name=$node_name °=$attrib ");
		}
		$id = $this->id_num;
		$this->id_num++;
		$this->node[$id][1] = $node_name;
		$this->node[$id][2] = $parent;
		$this->node[$id][6] = 0;
		$this->node[$id][8] = 0;
		$this->node[$id][5] = 0;
		$this->node[$id][11] = $ns;

		if($id == 0){
			$this->node_level = 0;
			$this->max_level = 0;
		}else{
			if($parent == -1){
				$this->node_level = 0;
			}else{
				$this->node_level = $this->node[$parent][3] + 1;
			}
			if($this->max_level < $this->node_level){
				$this->max_level = $this->node_level;
			}
		}
		$this->node[$id][3] = $this->node_level;
		$this->add_attrib($id,$attrib);
		return $id;
	}

	function make_textnode($parent,$text){
		if((!is_int($parent)&&($parent == ""))||($parent<-1)||($parent>=$this->id_num)){
			die("<br>顼<br>make_textnode:ƥΡֹ椬۾Ǥparent=$parent text=$text");
		}
		$id = $this->id_num;
		$this->id_num++;
		$this->node[$id][1] = "0text";
		$this->node[$id][2] = $parent;
		$this->node[$id][4] = $text;
		$this->node[$id][6] = 0;
		$this->node[$id][5]=1;

		if($id == 0){
			$this->node_level = 0;
			$this->max_level = 0;
		}else{
			if($parent == -1){
				$this->node_level = 0;
			}else{
				$this->node_level = $this->node[$parent][3] + 1;
			}
			if($this->max_level < $this->node_level){
				$this->max_level = $this->node_level;
			}
		}
		$this->node[$id][3] = $this->node_level;
		return $id;
	}

	function make_root($node_name,$attrib,$ns){
		$this->dtd_block = "";		//	DTD֥åѥХåե
		$this->pi_block = "";		//	PI֥åѥХåե
		$this->xml_block = "";		//	XMLΥХåե
		$this->comment_block = "";	//	ȥ֥åѥХåե

		$this->node = array();		//node
		$this->id_num = 0;			//nodeθĿ
		$this->node_level = 0;		//nodeγ
		$this->max_level = 0;		//nodeؤκ
		$this->id_tmp = -1;			//	ΡIDΥХåե
		$this->text_tmp="";			//	ƥȥХåե
		$this->entity = array();	//	Τ
		$this->entity_flg = 0;		//	ե饰

		$id = $this->make_node(-1,$node_name,$attrib,$ns);
		$this->root_flg = 1;
		return $id;
	}

	function add_child($id,$child){
		if((!is_int($id)&&($id == ""))||($id<0)||($id>=$this->id_num)){
			die("<br>顼<br>add_child:Ρֹ椬۾Ǥid=$id child=$child");
		}else if((!is_int($child)&&($child == ""))||($child<0)||($child>=$this->id_num)){
			die("<br>顼<br>add_child:ҥΡֹ椬۾Ǥid=$id child=$child");
		}else{
			$num = $this->node[$id][6];
			$this->node[$id][7][$num] = $child;
			$num++;
			$this->node[$id][6] = $num;
			$this->node[$child][2]=$id;
		}
	}
	function insert_child($id,$child,$index){
		if((!is_int($id)&&($id == ""))||($id<0)||($id>=$this->id_num)){
			die("<br>顼<br>insert_child:Ρֹ椬۾Ǥid=$id child=$child index=$index");
		}else if((!is_int($child)&&($child == ""))||($child<0)||($child>=$this->id_num)){
			die("<br>顼<br>insert_child:ҥΡֹ椬۾Ǥid=$id child=$child index=$index");
		}else{
			$num = $this->node[$id][6];
			if($index < 0){
				die ("<br>顼<br>insert_child:֤۾Ǥid=$id child=$child index=$index");
			}
			if($num == 0){
				if($index == 0){
					$this->add_child($id,$child);
				}else{
					die ("<br>顼<br>insert_child:֤۾Ǥid=$id child=$child index=$index");
				}
			}else if($num <$index){
				die ("<br>顼<br>insert_child:֤۾Ǥid=$id child=$child index=$index");
			}else{
				for($i=$num-1;$i>=$index;$i--){
					$tmp = $this->node[$id][7][$i];
					$this->node[$id][7][$i+1]=$tmp;
				}
				$this->node[$id][7][$index] = $child;
				$num++;
				$this->node[$id][6] = $num;
				$this->node[$child][2]=$id;
			}
		}
	}

	function add_textnode($parent,$text){
		if((!is_int($parent)&&($parent == ""))||($parent<0)||($parent>=$this->id_num)){
			die("<br>顼<br>add_textnode:Ρֹ椬۾Ǥid=$parent text=$text");
		}
		$id = $this->make_textnode($parent,$text);
		$this->add_child($parent,$id);
		return $id;
	}

	function add_node($parent,$node_name,$attrib,$ns){
		if($this->root_flg == 0){
			if($parent != -1){
				die("<br>顼<br>add_node:롼ȥΡɺΡֹ椬۾Ǥid=$parent node_name=$node_name °=$attrib");
			}
			$id = $this->make_node($parent,$node_name,$attrib,$ns);
			$this->root_flg = 1;
		}else{	
			if((!is_int($parent)&&($parent == ""))||($parent<0)||($parent>=$this->id_num)){
				die("<br>顼<br>add_node:Ρֹ椬۾Ǥid=$parent node_name=$node_name °=$attrib");
			}
			$id = $this->make_node($parent,$node_name,$attrib,$ns);
	
			$this->add_child($parent,$id);
		}
		return $id;
	}
	function insert_textnode($parent,$index,$text){
		if((!is_int($parent)&&($parent == ""))||($parent<0)||($parent>=$this->id_num)){
			die("<br>顼<br>insert_textnode:Ρֹ椬۾Ǥid=$parent node_name=$node_name °=$attrib");
		}
		$id = $this->make_textnode($parent,$text);
		$this->insert_child($parent,$id,$index);
		return $id;
	}
	function insert_node($parent,$index,$node_name,$attrib,$ns){
		if((!is_int($parent)&&($parent == ""))||($parent<0)||($parent>=$this->id_num)){
			die("<br>顼<br>insert_node:Ρֹ椬۾Ǥid=$parent node_name=$node_name °=$attrib");
		}
		$id = $this->make_node($parent,$node_name,$attrib,$ns);
		$this->insert_child($parent,$id,$index);
		return $id;
	}

	function split_NS(&$name){
		$ns = "";
		if(preg_match("/:/",$name)){
			list($ns,$name) = explode(":",$name);
		}
		return $ns;
	}
	
	function piblock($pi){			//̿
		$pi = preg_replace("/\r\n/","\r",$pi);
		$pi = preg_replace("/\r/","\n",$pi);
		$pos = 2;
		$target = "";
		while(1){
			$c = substr($pi,$pos++,1);
			if(($c == "\n")||($c == " "))
				break;
			$target .= $c;
		}
		$data = substr($pi,$pos);
		$pos = strpos($data,"?>");
		$data = trim(substr($data,0,$pos));
		if(preg_match("/xml-stylesheet/i",$target)){
			$this->pi_block .= "<?${target}\n\t${data}\n?>\n";
		}else if(preg_match("/<?xml/i",$pi)){
			$this->xml_block .= $pi;
		}else{
			$this->pi_block .= "<?${target}\n\t${data}\n?>\n";
		}
	}

	function dtdblock($dtd){		//DTD֥å
		$dtd_tmp = preg_split("/\n/",$dtd);
		foreach ($dtd_tmp as $line => $value){
//		while (list($line, $value) = each($dtd_tmp)) {
			if(preg_match("/<!ENTITY/i",$value)){		//Τγ
				$value = trim($value);
				$value = preg_replace("/&#38;/","&",$value);
				$value = preg_replace("/>/"," >",$value);
				$tmp = preg_split("/ /",$value);
				$value = "";
				$name = "";
				for($i=1;$i<count($tmp)-1;$i++){
					if($tmp[$i] != ""){
						if($name == ""){
							$name = $tmp[$i];
						}else{
							if($name == "lt")
								$value = "&lt;";
							else if($name == "gt")
								$value = "&gt;";
							else
								$value .= $tmp[$i];
						}
					}
				}
				if($tmp[count($tmp)-1] != ">"){
					die("<br>顼<br>dtdblock:DTDμ۾Ǥ");
				}
				$this->entity[$name]=preg_replace("/\"/","",$value);
			}
		}
		$this->dtd_block .= $dtd;
	}

	function commentblock($comment){		//
		$this->comment_block .= $comment;
	}

	function characters($text,$flg){		//ƥȥΡɤ
		$text = str_replace("&amp;","&",$text);
		$text = str_replace("&quot;","\"",$text);
		$text = str_replace("&apos;","'",$text);
		$tmp = $text;
		$text = trim($text);	
		if(($this->kaigyou[$this->level2] == 1)&&($text != "")){
			$this->text_tmp .= "\n";
			$this->text_tmp .= $text;
		}else{
			$this->text_tmp .= $text;
			$this->kaigyou[$this->level2] = 1;
		}
		if($flg==1){
//		if(ereg("\n",$tmp)||($flg==1)){
			if($this->text_tmp != ""){
				if($this->dtd_block == ""){
					$this->add_textnode($this->id_tmp,$this->text_tmp);
					$this->text_tmp = "";
				}else{
					//νʥƥȥΡ
					$tmp1 = $this->text_tmp;
					$tmp2 = "";
					while(1){
						$pos = strpos($tmp1,"&");
						if(!is_long($pos) && !$pos){
							$tmp2 .= $tmp1;
							break;
						}
						$tmp2 .= substr($tmp1,0,$pos);
						$tmp1 = substr($tmp1,$pos+1);
						$pos2 = strpos($tmp1,";");
						if(!is_long($pos2)&& !$pos2){
							$tmp2 .= "&" . $tmp1;
							break;
						}else{
							$tmp3 = substr($tmp1,0,$pos2);
							$tmp1 = substr($tmp1,$pos2+1);
							$entity_flg = 0;
							reset($this->entity);
							foreach ($this->entity as $name => $value){
//							while (list($name, $value) = each($this->entity)) {
								if($name == $tmp3){
									$entity_flg = 1;
									break;
								}
							}
							if($entity_flg == 1){
								$tmp4 = $this->entity[$tmp3];
							}else{
								$line_no = $this->line_num + 1;
								die("<br>顼<br>characters:ΤλȤ۾Ǥ${line_no}նᡣ$this->text_tmp");
							}
							$tmp2 .= $tmp4;
						}
					}
					$this->add_textnode($this->id_tmp,$tmp2);
					$this->text_tmp = "";
				}
			}
		}
	}

	function startDocument(){		//ʸγ
		$this->level2 = 0;
		$this->kaigyou[0] = 0;
	}

	function endDocument(){			//ʸνλ
	}
	
	function startElement($ns,$name,$attrib){	//Ǥγ
		if($this->text_tmp != ""){
			$text = $this->text_tmp;
			$this->characters($text,1);
			$this->text_tmp = "";
		}
		$this->id_tmp = $this->add_node($this->id_tmp,$name,$attrib,$ns);
		$this->level2++;
		// ʲɲ
		$this->kaigyou[$this->level2] = 0;
	}

	function endElement($ns,$name){		//Ǥνλ
		$this->kaigyou[$this->level2] = 0;
		$this->level2--;
		if($this->text_tmp != ""){
			if($this->dtd_block == ""){
				$this->add_textnode($this->id_tmp,$this->text_tmp);
				$this->text_tmp = "";
			}else{
				//νʥƥȥΡ
				$tmp1 = $this->text_tmp;
				$tmp2 = "";
				while(1){
					$pos = strpos($tmp1,"&");
					if(!is_long($pos) && !$pos){
						$tmp2 .= $tmp1;
						break;
					}
					$tmp2 .= substr($tmp1,0,$pos);
					$tmp1 = substr($tmp1,$pos+1);
					$pos2 = strpos($tmp1,";");
					if(!is_long($pos2)&& !$pos2){
						$tmp2 .= "&" . $tmp1;
						break;
					}else{
						$tmp3 = substr($tmp1,0,$pos2);
						$tmp1 = substr($tmp1,$pos2+1);
						$entity_flg = 0;
						reset($this->entity);
						foreach ($this->entity as $name => $value){
//						while (list($name, $value) = each($this->entity)) {
							if($name == $tmp3){
								$entity_flg = 1;
								break;
							}
						}
						if($entity_flg == 1){
						$tmp4 = $this->entity[$tmp3];
						}else{
							$line_no = $this->line_num + 1;
							die("<br>顼<br>endElement:ΤλȤ۾Ǥ${line_no}նᡣ$this->text_tmp");
						}
						$tmp2 .= $tmp4;
					}
				}
				$this->add_textnode($this->id_tmp,$tmp2);
				$this->text_tmp = "";
			}
		}
		$id = $this->id_tmp;
		$this->id_tmp = $this->node[$id][2];
	}
	function textcheck($text){
		$tmp = $text;
		$text = trim($text);
		if(preg_match("/\n/",$tmp)&&($text != ""))
			$text .= "\n";
		if($text != ""){
			while(1){
				$c = substr($text,0,1);
				if ($c != "<") {					//Textnode
					$pos = strpos($text,"<");
					if($pos == 0){
/*						if(ereg(">",$text)){
							$line_no = $this->line_num + 1;
							print "<br>顼<br>textcheck:ƥǤ&gt;иޤ${line_no}նᡣ$text";
							exit;
						}
*/
						//textnode
						if($this->root_flg != 1){
							$line_no = $this->line_num + 1;
							print "<br>顼<br>textcheck:ְä˥ƥȤиޤ${line_no}նᡣ$text";
							exit;
						}
						$this->characters($text,0);
						break;
					}else{
						$sub = substr($text,0,$pos);
						$text = substr($text,$pos);
/*						if(ereg(">",$sub)){
							$line_no = $this->line_num + 1;
							print "<br>顼<br>textcheck:ƥǤ&gt;иޤ${line_no}նᡣ$sub";
							exit;
						}
*/
						//textnode
						$this->characters($sub,0);
					}
				}else{
					$c = substr($text,1,1);
					if($c == "/"){					//Ĥ
						$len = strlen($text);
						$pos = strpos($text , ">");
						$name = substr($text,2,$pos-2);
						if(preg_match("/</",$name)){
							$line_no = $this->line_num + 1;
							print "<br>顼<br>textcheck:Ĥ&lt;иޤ${line_no}նᡣ$name";
							exit;
						}
						$text = substr($text,$pos+1);
						//endNode
						$name = chop($name);
						if($this->tmp_node[$this->tmp_index] != $name){
							$tmp = $this->tmp_node[$this->tmp_index];
							$line_no = $this->line_num + 1;
							print "<br>顼<br>textcheck:Υߥޥåȯޤ${line_no}նᡣϥ:${tmp} Ĥ:${name}";
							exit;
						}
						$ns = $this->split_NS($name);
						$this->endElement($ns,$name);
						$this->tmp_index--;
						if($pos == $len-1){
							break;
						}
					}else{							//̾Υ
						$pos = strpos($text,">");
						$len = strlen($text);
						$c = substr($text,$pos-1,1);
						if($c == "/"){				//	Ĥξά
							$name = substr($text,1,$pos-2);
							$name = str_replace("\n"," ",$name);
							$name = str_replace("\r"," ",$name);
							$name = str_replace("\t"," ",$name);
							$pos2 = strpos($name , " ");
							if(!is_long($pos2) && !$pos2) {
								$attrib = "";
							}else{
								$attrib = substr($name , $pos2+1);
								$name = substr($name , 0 , $pos2);
							}
							if(preg_match("/</",$name)){
								$line_no = $this->line_num + 1;
								print "<br>顼<br>textcheck:&lt;иޤ${line_no}նᡣ$name";
								exit;
							}
							if(preg_match("/</",$attrib)){
								$line_no = $this->line_num + 1;
								print "<br>顼<br>textcheck:°&lt;иޤ${line_no}նᡣ$attrib";
								exit;
							}
							//startnode,endnode
							if($this->tmp_index == 0){
								if($this->root_flg == 1){
									$line_no = $this->line_num + 1;
									print "<br>顼<br>textcheck:ɥȥ롼Ȥİʾ夢ޤ${line_no}նᡣ$name";
									exit;
								}else{
									$root_flg = 1;
								}
							}
							$ns = $this->split_NS($name);
							$this->startElement($ns,$name,$attrib);
							$this->endElement($ns,$name);
							if($pos == $len-1){
								break;
							}
							$text = substr($text,$pos+1);
						}else{
							$name = substr($text,1,$pos-1);
							$name = str_replace("\n"," ",$name);
							$name = str_replace("\r"," ",$name);
							$name = str_replace("\t"," ",$name);
							$pos2 = strpos($name , " ");
							if(!is_long($pos2) && !$pos2) {
								$attrib = "";
							}else{
								$attrib = substr($name , $pos2+1);
								$name = substr($name , 0 , $pos2);
							}
							if(preg_match("/</",$name)){
								$line_no = $this->line_num + 1;
								print "<br>顼<br>textcheck:&lt;иޤ${line_no}նᡣ$name";
								exit;
							}
							if(preg_match("/</",$attrib)){
								$line_no = $this->line_num + 1;
								print "<br>顼<br>textcheck:°&lt;иޤ${line_no}նᡣ$attrib";
								exit;
							}
							//startnode
							if($this->tmp_index == 0){
								if($this->root_flg == 1){
									$line_no = $this->line_num + 1;
									print "<br>顼<br>textcheck:ɥȥ롼Ȥİʾ夢ޤ${line_no}նᡣ$name";
									exit;
								}
							}
							$this->tmp_index++;
							$this->tmp_node[$this->tmp_index] = $name;
							$ns = $this->split_NS($name);
							$this->startElement($ns,$name,$attrib);
							if($pos == $len-1){
								break;
							}
							$text = substr($text,$pos+1);
						}
					}
				}
			}
		}
	}

	function blockcheck($block){
		if ($this->comment_flg == 1){
			$this->comment .= $block;
		}else if($this->pi_flg == 1){
			$this->pi .= $block;
		}else if ($this->dtd_flg == 1){
			$this->dtd .= $block;
		}else{
			$tmp = $block;
			$block = trim($block);
			if(preg_match("/\n/",$tmp)&&($block != ""))
				$block .= "\n";
			$pos = strrpos($block,"<");
			if(!is_long($pos) && !$pos) {		//γϤʤ
				if($this->block_flg == 0){
					$this->textcheck($block); 
				}else{							//
					$pos2 = strrpos($block,">");
					if(!is_long($pos2) && !$pos2) {		//νλʤ
						$this->line_buff .= " " . $block;
					}else{
						$this->line_buff .= " " . $block;
						$this->block_flg = 0;
						$this->textcheck($this->line_buff); 
						$this->line_buff = "";
					}
				}
			}else{
				$pos2 = strrpos($block,">");
				if(!is_long($pos2) && !$pos2) {		//νλʤ
					if($this->block_flg == 1){
						$this->line_buff .= " " . $block;
					}else{
						$this->block_flg = 1;
						$this->line_buff = $block;
					}
				}else{
					if($pos2 < $pos){				//ǸΥνλʤ
						if($this->block_flg == 1){
							$this->line_buff .= " " . $block;
						}else{
							$this->block_flg = 1;
							$this->line_buff = $block;
						}
					}else{
						if($this->block_flg == 1){			//
							$this->line_buff .= " " . $block;
							$this->block_flg = 0;
							$this->textcheck($this->line_buff); 
							$this->line_buff = "";
						}else{						//̾
							$this->textcheck($block); 
						}
					}
				}
			}
		}
	}

	function saxparser($text){
		$text = preg_replace("/\r\n/","\n",$text);
		$text = preg_replace("/\r/","\n",$text);
		$fcontents = preg_split("/\n/",$text);	
		$this->startDocument();
		foreach ($fcontents as $this->line_num => $line){
//		while (list ($this->line_num, $line) = each ($fcontents)) {
			$line .="\n";
			$len = strlen($line);
			$i = 0;
			$tmp = "";
			if($this->comment_flg == 1){		//
				if(preg_match("/-->/",$line)){
					$pos2 = strpos($line,"-->");
					$this->comment .= substr($line,0,$pos2+3);
					$this->comment_flg = 0;
					$this->blockcheck($tmp);
					$this->commentblock($this->comment);
					$this->comment = "";
					$line = substr($line,$pos2+3);
					$len = strlen($line);
					$i = 0;
				}else{
					$this->comment .= $line;
					$len = 0;
					$i = 0;
				}
			}
			while($i < $len){
				$c = substr($line,$i,1);
				if($c == "<"){
					$c1 = substr($line,$i,2);
					if($c1 == "<?"){	//̿
						$this->blockcheck($tmp);
						$tmp = "";
						$this->pi = "<?";
						$this->pi_flg = 1;
						$i += 2;
					}else if($c1 == "<!"){
						$c2 = substr($line,$i,4);
						if($c2 == "<!--"){		//
							if($this->pi_flg == 1){
								$line_no = $this->line_num + 1;
								print "<br>顼<br>saxparser:PI˥ȤϵҤǤޤ${line_no}նᡣ";
								exit;
							}	
							$this->blockcheck($tmp);
							$this->comment_flg = 1;
							$tmp = "<!--";
							$i+= 4;
						}else{
							$c3 = substr($line,$i,9);
							if(preg_match("/<!DOCTYPE/i",$c3)){	//DTD
								if($this->pi_flg == 1){
									$line_no = $this->line_num + 1;
									print "<br>顼<br>saxparser:PIDTDϵҤǤޤ${line_no}նᡣ";
									exit;
								}
								if($this->comment_flg != 1){	
									$this->blockcheck($tmp);
									$this->dtd_flg = 1;
								}
								$tmp = "<!DOCTYPE";
								$i += 9;
							}else{	//DTD
								if($this->dtd_flg != 1){
									$line_no = $this->line_num + 1;
									print "<br>顼<br>saxparser:DTDإå̵ΤDTDиޤ${line_no}նᡣ";
									exit;
								}	
								$tmp .= $c1;
								$i += 2;
							}
						}
					}else{
						$tmp .= $c;
						$i++;
					}
				}else if($c == "?"){
					$c1 = substr($line,$i,2);
					if($c1 == "?>"){		//PIλ
						if($this->pi_flg != 1){
							$line_no = $this->line_num + 1;
							print "<br>顼<br>saxparser:PIإå̵ΤPIλ䤬иޤ${line_no}նᡣ";
							exit;
						}
						$tmp .= "?>\n";
						$this->blockcheck($tmp);
						$this->pi_flg = 0;
						$this->piblock($this->pi);
						$this->pi = "";
						$i+=2;
						$tmp = "";
					}else{
						$tmp .= $c;
						$i++;
					}
				}else if($c == "]"){
					$c1 = substr($line,$i,2);
					if($c1 == "]>"){		//DTDλ
						if($this->dtd_flg != 1){
							$line_no = $this->line_num + 1;
							print "<br>顼<br>saxparser:DTDإå̵ΤDTDλ䤬иޤ${line_no}նᡣ";
							exit;
						}
						$tmp .= "]>\n";
						$this->blockcheck($tmp);
						$this->dtd_flg = 0;
						$this->dtdblock($this->dtd);
						$this->dtd = "";
						$i += 2;
						$tmp = "";
					}else{
						$tmp .= $c;
						$i++;
					}
				}else if($c == "-"){
					$c1 = substr($line,$i,3);
					if($c1 == "-->"){		//Ƚλ
						$tmp .= "-->";
						$this->blockcheck($tmp);
						$this->commentblock($this->comment);
						$this->comment_flg=0;
						$this->comment="";
						$tmp = "";
						$i += 3;
					}else{
						$tmp .= $c;
						$i++;
					}
				}else{
					$tmp .= $c;
					$i++;
				}
			}
			if($tmp != ""){
				$this->blockcheck($tmp);
			}
		}
		if($this->dtd_flg == 1){
			$this->dtd = preg_replace("/</","&lt;",$this->dtd);
			$this->dtd = preg_replace("/>/","&gt;",$this->dtd);
			$this->dtd = preg_replace("/\n/","<br>",$this->dtd);
			print "<br>顼<br>saxparser:DTD֥åλƤޤ<br>$this->dtd";
			exit;
		}
		if($this->pi_flg == 1){
			$this->pi = preg_replace("/</","&lt;",$this->pi);
			$this->pi = preg_replace("/>/","&gt;",$this->pi);
			$this->pi = preg_replace("/\n/","<br>",$this->pi);
			print "<br>顼<br>saxparser:PI֥åλƤޤ$this->pi";
			exit;
		}
		if($this->comment_flg == 1){
			$this->comment = preg_replace("/</","&lt;",$this->comment);
			$this->comment = preg_replace("/>/","&gt;",$this->comment);
			$this->comment = preg_replace("/\n/","<br>",$this->comment);
			print "<br>顼<br>saxparser:ȥ֥åλƤޤ$this->comment";
			exit;
		}
		if($this->root_flg == 0){
			print "<br>顼<br>saxparser:ɥȥ롼Ȥޤ";
			exit;
		}
		if($this->tmp_index != 0){
			print "<br>顼<br>saxparser:ɥȥ롼ȥĤ줺ʸãޤ";
			exit;
		}
		$this->endDocument();
	}


	function file2node($filename){
		if(!file_exists($filename)){
			print "<br>顼<br>file2node:${filename}ե뤬¸ߤޤ";
			exit;
		}
		$text = join('',file($filename));
		$this->saxparser($text);
	}					

	function is_text($id){
		if((!is_int($id)&&($id == ""))||($id<0)||($id>=$this->id_num)){
			die("<br>顼<br>is_text:Ρֹ椬۾Ǥid=$id");
		}
		if($this->node[$id][5] == 1){
			return true;
		}else{
			return false;
		}
	}
	function get_text($id){
		if((!is_int($id)&&($id == ""))||($id<0)||($id>=$this->id_num)){
			die("<br>顼<br>get_text:Ρֹ椬۾Ǥid=$id");
		}
		$value = "";
		if($this->node[$id][5] == 1){
			$value = $this->node[$id][4];
		}
		return $value;
	}
	function get_value($id){
		if((!is_int($id)&&($id == ""))||($id<0)||($id>=$this->id_num)){
			die("<br>顼<br>get_value:Ρֹ椬۾Ǥid=$id");
		}
		if($this->is_text($id)){
			$value = $this->node[$id][4];
		}else{
			$value = "";
			$num = $this->node[$id][6];
			for($i=0;$i<$num;$i++){
				$id_2 = $this->node[$id][7][$i];
				if($this->node[$id_2][5] == 1){
					if($value != ""){
						$value = trim($value) . "\n";
					}
					$value .= $this->node[$id_2][4];
				}
			}
		}
		return $value;
	}
	function get_child_value($id,$node_name){
		if((!is_int($id)&&($id == ""))||($id<0)||($id>=$this->id_num)){
			die("<br>顼<br>get_child_value:Ρֹ椬۾Ǥid=$id node_name=$node_name");
		}
		$num = $this->node[$id][6];
		$value = "";
		for($i=0;$i<$num;$i++){
			$id_2 = $this->node[$id][7][$i];
			if($this->node[$id_2][1] == $node_name ){
				$value .= $this->get_value($id_2);
				return $value;
			}
		}
		return $value;
	}
	function get_child_value_ns($id,$node_name,$ns){
		if((!is_int($id)&&($id == ""))||($id<0)||($id>=$this->id_num)){
			die("<br>顼<br>get_child_value:Ρֹ椬۾Ǥid=$id node_name=$node_name");
		}
		$num = $this->node[$id][6];
		$value = "";
		for($i=0;$i<$num;$i++){
			$id_2 = $this->node[$id][7][$i];
			if(($this->node[$id_2][1] == $node_name )&&($this->node[$id_2][11] == $ns)){
				$value .= $this->get_value($id_2);
				return $value;
			}
		}
		return $value;
	}
	function get_node_name($id){
		if((!is_int($id)&&($id == ""))||($id<0)||($id>=$this->id_num)){
			die("<br>顼<br>get_node_name:Ρֹ椬۾Ǥid=$id");
		}
		if($this->node[$id][5] == 1){
			return "";
		}
		$name = $this->node[$id][1];
		return $name;
	}
	function get_ns($id){
		if((!is_int($id)&&($id == ""))||($id<0)||($id>=$this->id_num)){
			die("<br>顼<br>get_ns:Ρֹ椬۾Ǥid=$id");
		}
		if($this->node[$id][5] == 1){
			return "";
		}
		$ns = $this->node[$id][11];
		return $ns;
	}
	function get_uri($ns,$id){
		if((!is_int($id)&&($id == ""))||($id<0)||($id>=$this->id_num)){
			die("<br>顼<br>get_ns:Ρֹ椬۾Ǥid=$id ns=$ns");
		}
		$ns_uri = "";
		if($ns == ""){
			if($this->nsd_index != 0){
				while(1){
					for($i=0;$i<$this->nsd_index;$i++){
						$id_temp = $this->ns_default[$i][2];
						if($id == $id_temp){
							$ns_uri = $this->ns_default[$i][1];
							break;
						}
					}
					if($ns_uri == ""){
						if($id == 0) break;
						$id = $this->get_parent($id);
					}else{
						break;
					}
				}
			}
		}else{
			if(isset($this->uri[$ns])){
				$ns_uri = $this->uri[$ns];
			}
		}
		return $ns_uri;
	}
	function get_parent($id){
		if((!is_int($id)&&($id == ""))||($id<0)||($id>=$this->id_num)){
			die("<br>顼<br>get_parent:Ρֹ椬۾Ǥid=$id");
		}
		$parent = $this->node[$id][2];
		return $parent;
	}
	function del_child($id,$child){
		if((!is_int($id)&&($id == ""))||($id<0)||($id>=$this->id_num)){
			die("<br>顼<br>del_child:Ρֹ椬۾Ǥid=$id child=$child");
		}else if((!is_int($child)&&($child == ""))||($child<0)||($child>=$this->id_num)){
			die("<br>顼<br>del_child:ҥΡֹ椬۾Ǥid=$id child=$child");
		}
		$num = $this->node[$id][6];
		$del_ok = false;
		for($i=0;$i<$num;$i++){
			$temp = $this->node[$id][7][$i];
			if($del_ok){
				$this->node[$id][7][$i-1] = $temp;
			}else if($temp == $child){
				$del_ok = true;
			}
		}
		if($del_ok){
			$num --;
			$this->node[$id][6] = $num;
		}
		return $del_ok;
	}
	function del_child_node($id,$child_name){
		if((!is_int($id)&&($id == ""))||($id<0)||($id>=$this->id_num)){
			die("<br>顼<br>del_child_node:Ρֹ椬۾Ǥid=$id child_name=$child_name");
		}
		$num = $this->node[$id][6];
		$del_ok = false;
		$shift = 0;
		for($i=0;$i<$num;$i++){
			$id2 = $this->node[$id][7][$i];
			$temp_name = $this->get_node_name($id2);
			if($del_ok){
				if($temp_name == $child_name){
					$shift++;
				}else{
					$this->node[$id][7][$i-$shift] = $id2;
				}
			}else if($temp_name == $child_name){
				$del_ok = true;
				$shift = 1;
			}
		}
		if($del_ok){
			$num -= $shift;
			$this->node[$id][6] = $num;
		}
		return $del_ok;
	}
	function del_child_node_ns($id,$child_name,$ns){
		if((!is_int($id)&&($id == ""))||($id<0)||($id>=$this->id_num)){
			die("<br>顼<br>del_child_node_ns:Ρֹ椬۾Ǥid=$id child_name=$child_name");
		}
		$num = $this->node[$id][6];
		$del_ok = false;
		$shift = 0;
		for($i=0;$i<$num;$i++){
			$id2 = $this->node[$id][7][$i];
			$temp_name = $this->get_node_name($id2);
			$temp_ns = $this->get_ns($id2);
			if($del_ok){
				if(($temp_name == $child_name)&&($temp_ns == $ns)){
					$shift++;
				}else{
					$this->node[$id][7][$i-$shift] = $id2;
				}
			}else if(($temp_name == $child_name)&&($temp_ns == $ns)){
				$del_ok = true;
				$shift = 1;
			}
		}
		if($del_ok){
			$num -= $shift;
			$this->node[$id][6] = $num;
		}
		return $del_ok;
	}
	function del_attrib($id,$attrib){
		if((!is_int($id)&&($id == ""))||($id<0)||($id>=$this->id_num)){
			die("<br>顼<br>del_attrib:Ρֹ椬۾Ǥid=$id °=$attrib");
		}
		$num = $this->node[$id][8];
		$del_ok = false;
		$shift = 0;
		for($i=0;$i<$num;$i++){
			$temp_name = $this->node[$id][9][$i];
			$tmp = $this->node[$id][10][$i];
			if($del_ok){
				if($temp_name == $attrib){
					$shift++;
				}else{
					$this->node[$id][9][$i-$shift] = $temp_name;
					$this->node[$id][10][$i-$shift] = $temp;
				}
			}else if($temp_name == $attrib){
				$del_ok = true;
				$shift = 1;
			}
		}
		if($del_ok){
			$num-= $shift;
			$this->node[$id][8] = $num;
		}
		return $del_ok;
	}
	function del_node($id){
		if((!is_int($id)&&($id == ""))||($id<0)||($id>=$this->id_num)){
			die("<br>顼<br>del_node:Ρֹ椬۾Ǥid=$id");
		}
		if($id != 0){
			$parent = $this->node[$id][2];
			$del_ok = $this->del_child($parent,$id);
		}else{
			$del_ok = false;
		}
		return $del_ok;
	}
	function get_singlenode($text){
		if($text == ""){
			return "";
		}
		$node_name = array();
		$node_name = explode("/",$text);
		$this->node_level = count($node_name);
		$node_array = array();
		$node_array_sub = array();
		$child = 0;
		if($this->node[0][1] == $node_name[0]){
			$child = 1;
			$node_array[0] = 0;
			for($i=1;$i<$this->node_level;$i++){
				$node_array_sub_su = count($node_array_sub);
				for($k=0;$k<$node_array_sub_su;$k++){
					$node_array_sub[$k] = "";
				}
				$node_array_su = count($node_array);
				for($k=0;$k<$node_array_su;$k++){
					$node_array_sub[$k] = $node_array[$k];
					$node_array[$k] = "";
				}
				$child = 0;
				for($k=0;$k<$node_array_su;$k++){
					$id = $node_array_sub[$k];
					if(is_int($id)){
						$num = $this->node[$id][6];
						for($j=0;$j<$num;$j++){
							$id_2 = $this->node[$id][7][$j];
							if($this->node[$id_2][1] == $node_name[$i]){
								$node_array[$child] = $id_2;
								$child++;
							}
						}
					}
				}
			}
			if($child == 0){
				$dummy = array();
				$node_array = $dummy;
			}
		}
		if($child == 0){
			return "";
		}else{
			return $node_array[0];
		}
	}
	function get_singlenode_ns($text,$ns){
		if($text == ""){
			return "";
		}
		$node_name = array();
		$node_name = explode("/",$text);
		$this->node_level = count($node_name);
		$node_array = array();
		$node_array_sub = array();
		$child = 0;
		if($this->node[0][1] == $node_name[0]){
			$child = 1;
			$node_array[0] = 0;
			for($i=1;$i<$this->node_level;$i++){
				$node_array_sub_su = count($node_array_sub);
				for($k=0;$k<$node_array_sub_su;$k++){
					$node_array_sub[$k] = "";
				}
				$node_array_su = count($node_array);
				for($k=0;$k<$node_array_su;$k++){
					$node_array_sub[$k] = $node_array[$k];
					$node_array[$k] = "";
				}
				$child = 0;
				for($k=0;$k<$node_array_su;$k++){
					$id = $node_array_sub[$k];
					if(is_int($id)){
						$num = $this->node[$id][6];
						for($j=0;$j<$num;$j++){
							$id_2 = $this->node[$id][7][$j];
							if($this->node[$id_2][1] == $node_name[$i]){
								$node_array[$child] = $id_2;
								$child++;
							}
						}
					}
				}
			}
			if($child == 0){
				$dummy = array();
				$node_array = $dummy;
			}
		}
		$child = 0;
		$node_array2 = array();
		$node_array_su = count($node_array);
		for($k=0;$k<$node_array_su;$k++){
			$id = $node_array[$k];
			$node_array[$k] = "";
			if($this->node[$id][11] == $ns){
				$node_array2[$child] = $id;
				$child++;
			}
		}
		if($child == 0){
			return "";
		}else{
			return $node_array2[0];
		}
	}
	function get_node($text){
		if($text == ""){
			return "";
		}
		$node_name = array();
		$node_name = explode("/",$text);
		$this->node_level = count($node_name);
		$node_array = array();
		$node_array_sub = array();
		$child = 0;
		if($this->node[0][1] == $node_name[0]){
			$child = 1;
			$node_array[0] = 0;
			for($i=1;$i<$this->node_level;$i++){
				$node_array_sub_su = count($node_array_sub);
				for($k=0;$k<$node_array_sub_su;$k++){
					$node_array_sub[$k] = "";
				}
				$node_array_su = count($node_array);
				for($k=0;$k<$node_array_su;$k++){
					$node_array_sub[$k] = $node_array[$k];
					$node_array[$k] = "";
				}
				$child = 0;
				for($k=0;$k<$node_array_su;$k++){
					$id = $node_array_sub[$k];
					if(is_int($id)){
						$num = $this->node[$id][6];
						for($j=0;$j<$num;$j++){
							$id_2 = $this->node[$id][7][$j];
							if($this->node[$id_2][1] == $node_name[$i]){
								$node_array[$child] = $id_2;
								$child++;
							}
						}
					}
				}
			}
			if($child == 0){
				$dummy = array();
				$node_array = $dummy;
			}
		}
		return $node_array;
	}
	function get_node_ns($text,$ns){
		if($text == ""){
			return "";
		}
		$node_name = array();
		$node_name = explode("/",$text);
		$this->node_level = count($node_name);
		$node_array = array();
		$node_array_sub = array();
		$child = 0;
		if($this->node[0][1] == $node_name[0]){
			$child = 1;
			$node_array[0] = 0;
			for($i=1;$i<$this->node_level;$i++){
				$node_array_sub_su = count($node_array_sub);
				for($k=0;$k<$node_array_sub_su;$k++){
					$node_array_sub[$k] = "";
				}
				$node_array_su = count($node_array);
				for($k=0;$k<$node_array_su;$k++){
					$node_array_sub[$k] = $node_array[$k];
					$node_array[$k] = "";
				}
				$child = 0;
				for($k=0;$k<$node_array_su;$k++){
					$id = $node_array_sub[$k];
					if(is_int($id)){
						$num = $this->node[$id][6];
						for($j=0;$j<$num;$j++){
							$id_2 = $this->node[$id][7][$j];
							if($this->node[$id_2][1] == $node_name[$i]){
								$node_array[$child] = $id_2;
								$child++;
							}
						}
					}
				}
			}
			if($child == 0){
				$dummy = array();
				$node_array = $dummy;
			}
		}
		$child = 0;
		$node_array2 = array();
		$node_array_su = count($node_array);
		for($k=0;$k<$node_array_su;$k++){
			$id = $node_array[$k];
			$node_array[$k] = "";
			if($this->node[$id][11] == $ns){
				$node_array2[$child] = $id;
				$child++;
			}
		}
		return $node_array2;
	}
	function get_singlenode_r($id,$text){
		if((!is_int($id)&&($id == ""))||($id<0)||($id>=$this->id_num)){
			die("<br>顼<br>get_singlenode_r:Ρֹ椬۾Ǥid=$id text=$text");
		}
		if($text == ""){
			return "";
		}
		$node_name = array();
		$node_name = explode("/",$text);
		$this->node_level = count($node_name);
		$node_array = array();
		$node_array_sub = array();
		$node_array[0] = $id;
		for($i=0;$i<$this->node_level;$i++){
			$node_array_sub_su = count($node_array_sub);
			for($k=0;$k<$node_array_sub_su;$k++){
				$node_array_sub[$k] = "";
			}
			$node_array_su = count($node_array);
			for($k=0;$k<$node_array_su;$k++){
				$node_array_sub[$k] = $node_array[$k];
				$node_array[$k] = "";
			}
			$child = 0;
			for($k=0;$k<$node_array_su;$k++){
				$id = $node_array_sub[$k];
				if(is_int($id)){
					$num = $this->node[$id][6];
					for($j=0;$j<$num;$j++){
						$id_2 = $this->node[$id][7][$j];
						if($this->node[$id_2][1] == $node_name[$i]){
							$node_array[$child] = $id_2;
							$child++;
						}
					}
				}
			}
			if($child == 0){
				$dummy = array();
				$node_array = $dummy;
			}
		}
		if($child == 0){
			return "";
		}else{
			return $node_array[0];
		}
	}
	function get_singlenode_r_ns($id,$text,$ns){
		if((!is_int($id)&&($id == ""))||($id<0)||($id>=$this->id_num)){
			die("<br>顼<br>get_singlenode_r_ns:Ρֹ椬۾Ǥid=$id text=$text");
		}
		if($text == ""){
			return "";
		}
		$node_name = array();
		$node_name = explode("/",$text);
		$this->node_level = count($node_name);
		$node_array = array();
		$node_array_sub = array();
		$node_array[0] = $id;
		for($i=0;$i<$this->node_level;$i++){
			$node_array_sub_su = count($node_array_sub);
			for($k=0;$k<$node_array_sub_su;$k++){
				$node_array_sub[$k] = "";
			}
			$node_array_su = count($node_array);
			for($k=0;$k<$node_array_su;$k++){
				$node_array_sub[$k] = $node_array[$k];
				$node_array[$k] = "";
			}
			$child = 0;
			for($k=0;$k<$node_array_su;$k++){
				$id = $node_array_sub[$k];
				if(is_int($id)){
					$num = $this->node[$id][6];
					for($j=0;$j<$num;$j++){
						$id_2 = $this->node[$id][7][$j];
						if($this->node[$id_2][1] == $node_name[$i]){
							$node_array[$child] = $id_2;
							$child++;
						}
					}
				}
			}
			if($child == 0){
				$dummy = array();
				$node_array = $dummy;
			}
		}
		$child = 0;
		$node_array2 = array();
		$node_array_su = count($node_array);
		for($k=0;$k<$node_array_su;$k++){
			$id = $node_array[$k];
			$node_array[$k] = "";
			if($this->node[$id][11] == $ns){
				$node_array2[$child] = $id;
				$child++;
			}
		}
		if($child == 0){
			return "";
		}else{
			return $node_array2[0];
		}
	}
	function get_node_r($id,$text){
		if((!is_int($id)&&($id == ""))||($id<0)||($id>=$this->id_num)){
			die("<br>顼<br>get_node_r:Ρֹ椬۾Ǥid=$id text=$text");
		}
		if($text == ""){
			return "";
		}
		$node_name = array();
		$node_name = explode("/",$text);
		$this->node_level = count($node_name);
		$node_array = array();
		$node_array_sub = array();
		$node_array[0] = $id;
		for($i=0;$i<$this->node_level;$i++){
			$node_array_sub_su = count($node_array_sub);
			for($k=0;$k<$node_array_sub_su;$k++){
				$node_array_sub[$k] = "";
			}
			$node_array_su = count($node_array);
			for($k=0;$k<$node_array_su;$k++){
				$node_array_sub[$k] = $node_array[$k];
				$node_array[$k] = "";
			}
			$child = 0;
			for($k=0;$k<$node_array_su;$k++){
				$id = $node_array_sub[$k];
				if(is_int($id)){
					$num = $this->node[$id][6];
					for($j=0;$j<$num;$j++){
						$id_2 = $this->node[$id][7][$j];
						if($this->node[$id_2][1] == $node_name[$i]){
							$node_array[$child] = $id_2;
							$child++;
						}
					}
				}
			}
			if($child == 0){
				$dummy = array();
				$node_array = $dummy;
			}
		}
		return $node_array;
	}
	function get_node_r_ns($id,$text,$ns){
		if((!is_int($id)&&($id == ""))||($id<0)||($id>=$this->id_num)){
			die("<br>顼<br>get_node_r_ns:Ρֹ椬۾Ǥid=$id text=$text");
		}
		if($text == ""){
			return "";
		}
		$node_name = array();
		$node_name = explode("/",$text);
		$this->node_level = count($node_name);
		$node_array = array();
		$node_array_sub = array();
		$node_array[0] = $id;
		for($i=0;$i<$this->node_level;$i++){
			$node_array_sub_su = count($node_array_sub);
			for($k=0;$k<$node_array_sub_su;$k++){
				$node_array_sub[$k] = "";
			}
			$node_array_su = count($node_array);
			for($k=0;$k<$node_array_su;$k++){
				$node_array_sub[$k] = $node_array[$k];
				$node_array[$k] = "";
			}
			$child = 0;
			for($k=0;$k<$node_array_su;$k++){
				$id = $node_array_sub[$k];
				if(is_int($id)){
					$num = $this->node[$id][6];
					for($j=0;$j<$num;$j++){
						$id_2 = $this->node[$id][7][$j];
						if($this->node[$id_2][1] == $node_name[$i]){
							$node_array[$child] = $id_2;
							$child++;
						}
					}
				}
			}
			if($child == 0){
				$dummy = array();
				$node_array = $dummy;
			}
		}
		$child = 0;
		$node_array2 = array();
		$node_array_su = count($node_array);
		for($k=0;$k<$node_array_su;$k++){
			$id = $node_array[$k];
			$node_array[$k] = "";
			if($this->node[$id][11] == $ns){
				$node_array2[$child] = $id;
				$child++;
			}
		}
		return $node_array2;
	}

	function get_node_r_nsa($id,$path){
		if((!is_int($id)&&($id == ""))||($id<0)||($id>=$this->id_num)){
			die("<br>顼<br>get_node_r_nsa:Ρֹ椬۾Ǥid=$id path=$path");
		}
		if($path == ""){
			return "";
		}
		$temp = explode("/",$path);
		$num = count($temp);
		$node_array_sub = array();
		$node_array = array();
		$node_array[0] = $id;
		for($i=0;$i<$num;$i++){
			$node_name = $temp[$i];
			$ns = $this->split_NS($node_name);

			$node_array_sub_su = count($node_array_sub);
			for($k=0;$k<$node_array_sub_su;$k++){
				$node_array_sub[$k] = "";
			}
			$node_array_su = count($node_array);
			for($k=0;$k<$node_array_su;$k++){
				$node_array_sub[$k] = $node_array[$k];
				$node_array[$k] = "";
			}

			$child = 0;
			for($k=0;$k<$node_array_su;$k++){
				$id = $node_array_sub[$k];
				if(is_int($id)){
					$num2 = $this->node[$id][6];
					for($j=0;$j<$num2;$j++){
						$id_2 = $this->node[$id][7][$j];
						if(($this->node[$id_2][1] == $node_name)&&($this->node[$id_2][11] == $ns)){
							$node_array[$child] = $id_2;
							$child++;
						}
					}
				}
			}
			if($child == 0){
				$dummy = array();
				$node_array = $dummy;
				break;
			}
		}
		return $node_array;
	}
	function get_singlenode_r_nsa($id,$path){
		if((!is_int($id)&&($id == ""))||($id<0)||($id>=$this->id_num)){
			die("<br>顼<br>get_singlenode_r_nsa:Ρֹ椬۾Ǥid=$id path=$path");
		}
		if($path == ""){
			return "";
		}
		$temp = explode("/",$path);
		$num = count($temp);
		$node_array_sub = array();
		$node_array = array();
		$node_array[0] = $id;
		for($i=0;$i<$num;$i++){
			$node_name = $temp[$i];
			$ns = $this->split_NS($node_name);

			$node_array_sub_su = count($node_array_sub);
			for($k=0;$k<$node_array_sub_su;$k++){
				$node_array_sub[$k] = "";
			}
			$node_array_su = count($node_array);
			for($k=0;$k<$node_array_su;$k++){
				$node_array_sub[$k] = $node_array[$k];
				$node_array[$k] = "";
			}

			$child = 0;
			for($k=0;$k<$node_array_su;$k++){
				$id = $node_array_sub[$k];
				if(is_int($id)){
					$num2 = $this->node[$id][6];
					for($j=0;$j<$num2;$j++){
						$id_2 = $this->node[$id][7][$j];
						if(($this->node[$id_2][1] == $node_name)&&($this->node[$id_2][11] == $ns)){
							$node_array[$child] = $id_2;
							$child++;
						}
					}
				}
			}
			if($child == 0){
				$dummy = array();
				$node_array = $dummy;
				break;
			}
		}
		if($child == 0){
			return "";
		}else{
			return $node_array[0];
		}
	}
	function get_node_nsa($path){
		$temp = explode("/",$path);
		$num = count($temp);
		$node_array_sub = array();
		$node_array = array();
		$node_name = $temp[0];
		$ns = $this->split_NS($node_name);
		if(($this->node[0][1] == $node_name)&&($this->node[0][11] == $ns)){
			$child = 1;
			$node_array[0] = 0;
			for($i=1;$i<$num;$i++){
				$node_name = $temp[$i];
				$ns = $this->split_NS($node_name);

				$node_array_sub_su = count($node_array_sub);
				for($k=0;$k<$node_array_sub_su;$k++){
					$node_array_sub[$k] = "";
				}
				$node_array_su = count($node_array);
				for($k=0;$k<$node_array_su;$k++){
					$node_array_sub[$k] = $node_array[$k];
					$node_array[$k] = "";
				}

				$child = 0;
				for($k=0;$k<$node_array_su;$k++){
					$id = $node_array_sub[$k];
					if(is_int($id)){
						$num2 = $this->node[$id][6];
						for($j=0;$j<$num2;$j++){
							$id_2 = $this->node[$id][7][$j];
							if(($this->node[$id_2][1] == $node_name)&&($this->node[$id_2][11] == $ns)){
								$node_array[$child] = $id_2;
								$child++;
							}
						}
					}
				}
				if($child == 0){
					$dummy = array();
					$node_array = $dummy;
					break;
				}
			}
		}
		return $node_array;
	}
	function get_singlenode_nsa($path){
		$temp = explode("/",$path);
		$num = count($temp);
		$node_array_sub = array();
		$node_array = array();
		$node_name = $temp[0];
		$ns = $this->split_NS($node_name);
		if(($this->node[0][1] == $node_name)&&($this->node[0][11] == $ns)){
			$child = 1;
			$node_array[0] = 0;
			for($i=1;$i<$num;$i++){
				$node_name = $temp[$i];
				$ns = $this->split_NS($node_name);

				$node_array_sub_su = count($node_array_sub);
				for($k=0;$k<$node_array_sub_su;$k++){
					$node_array_sub[$k] = "";
				}
				$node_array_su = count($node_array);
				for($k=0;$k<$node_array_su;$k++){
					$node_array_sub[$k] = $node_array[$k];
					$node_array[$k] = "";
				}

				$child = 0;
				for($k=0;$k<$node_array_su;$k++){
					$id = $node_array_sub[$k];
					if(is_int($id)){
						$num2 = $this->node[$id][6];
						for($j=0;$j<$num2;$j++){
							$id_2 = $this->node[$id][7][$j];
							if(($this->node[$id_2][1] == $node_name)&&($this->node[$id_2][11] == $ns)){
								$node_array[$child] = $id_2;
								$child++;
							}
						}
					}
				}
				if($child == 0){
					$dummy = array();
					$node_array = $dummy;
					break;
				}
			}
		}
		if($child == 0){
			return "";
		}else{
			return $node_array[0];
		}
	}
	function get_child_node($id,$node_name){
		if((!is_int($id)&&($id == ""))||($id<0)||($id>=$this->id_num)){
			die("<br>顼<br>get_child_node:Ρֹ椬۾Ǥid=$id node_name=$node_name");
		}
		if($node_name == ""){
			return "";
		}
		$child = 0;
		$node_array = array();
		$num = $this->node[$id][6];
		for($j=0;$j<$num;$j++){
			$id_2 = $this->node[$id][7][$j];
			if($this->node[$id_2][1] == $node_name){
				$node_array[$child] = $id_2;
				$child++;
			}
		}
		return $node_array;
	}
	function get_child_node_ns($id,$node_name,$ns){
		if((!is_int($id)&&($id == ""))||($id<0)||($id>=$this->id_num)){
			die("<br>顼<br>get_child_node_ns:Ρֹ椬۾Ǥid=$id node_name=$node_name");
		}
		if($node_name == ""){
			return "";
		}
		$child = 0;
		$node_array = array();
		$num = $this->node[$id][6];
		for($j=0;$j<$num;$j++){
			$id_2 = $this->node[$id][7][$j];
			if(($this->node[$id_2][1] == $node_name)&&($this->node[$id_2][11] == $ns)){
				$node_array[$child] = $id_2;
				$child++;
			}
		}
		return $node_array;
	}
	function get_childs($id){
		if((!is_int($id)&&($id == ""))||($id<0)||($id>=$this->id_num)){
			die("<br>顼<br>get_childs:Ρֹ椬۾Ǥid=$id");
		}
		$node_array = array();
		$num = $this->node[$id][6];
		for($j=0;$j<$num;$j++){
			$id_2 = $this->node[$id][7][$j];
			$node_array[$j] = $id_2;
		}
		return $node_array;
	}
	function get_childs_ns($id,$ns){
		if((!is_int($id)&&($id == ""))||($id<0)||($id>=$this->id_num)){
			die("<br>顼<br>get_childs_ns:Ρֹ椬۾Ǥid=$id");
		}
		$node_array = array();
		$num = $this->node[$id][6];
		$l = 0;
		for($j=0;$j<$num;$j++){
			$id_2 = $this->node[$id][7][$j];
			if($this->node[$id_2][11] == $ns){
				$node_array[$l] = $id_2;
				$l++;
			}
		}
		return $node_array;
	}
	function get_root(){
		return(0);
	}
	function set_value($id,$value){
		if((!is_int($id)&&($id == ""))||($id<0)||($id>=$this->id_num)){
			die("<br>顼<br>set_value:Ρֹ椬۾Ǥid=$id value=$value");
		}
		$num = $this->node[$id][6];
		$flg = 0;
		$text_su = 0;
		for($i=0;$i<$num;$i++){
			$id_2 = $this->node[$id][7][$i];
			if($this->node[$id_2][5] == 1){
				if($flg == 0){
					$this->node[$id_2][4] = $value;
					$flg = 1;
				}else{
					for($j=$i+1;$j<$num;$j++){
						$this->node[$id][7][$j-1] = $this->node[$id][7][$j];
					}
					$num--;
					$i--;
				}
			}
		}
		if($flg != 1){
			$this->add_textnode($id,$value);
		}else{
			$this->node[$id][6] = $num;
		}
	}
	function set_text($id,$text){
		if((!is_int($id)&&($id == ""))||($id<0)||($id>=$this->id_num)){
			die("<br>顼<br>set_text:Ρֹ椬۾Ǥid=$id text=$text");
		}
		if($this->node[$id][5] == 1){
			$this->node[$id][4] = $text;
		}else{
			print "Ρֹ${id}ϥƥȥΡɤǤϤޤ\n";
			exit;
		}
	}
	function set_attrib($id,$attrib_name,$value){
		if((!is_int($id)&&($id == ""))||($id<0)||($id>=$this->id_num)){
			die("<br>顼<br>set_attrib:Ρֹ椬۾Ǥid=$id °̾=$attrib_name =$value");
		}
		$num = $this->node[$id][8];
		$set_ok = false;
		for($i=0;$i<$num;$i++){
			$name = $this->node[$id][9][$i];
			if($name == $attrib_name){
				$set_ok = true;
				$this->node[$id][10][$i] = $value;
				break;
			}
		}
		return $set_ok;
	}
	function get_attrib($id,$attrib_name){
		if((!is_int($id)&&($id == ""))||($id<0)||($id>=$this->id_num)){
			die("<br>顼<br>get_attrib:Ρֹ椬۾Ǥid=$id °̾=$attrib_name");
		}
		$num = $this->node[$id][8];
		$value="";
		for($i=0;$i<$num;$i++){
			$name = $this->node[$id][9][$i];
			if($name == $attrib_name){
				$value = $this->node[$id][10][$i];
				break;
			}
		}
		return $value;
	}
	function set_node_name($id,$name){
		if((!is_int($id)&&($id == ""))||($id<0)||($id>=$this->id_num)){
			die("<br>顼<br>set_node_name:Ρֹ椬۾Ǥid=$id name=$name");
		}
		$this->node[$id][1] = $name;
	}
	function set_ns($id,$ns){
		if((!is_int($id)&&($id == ""))||($id<0)||($id>=$this->id_num)){
			die("<br>顼<br>set_ns:Ρֹ椬۾Ǥid=$id");
		}
		$this->node[$id][11] = $ns;
	}
	function set_uri($ns,$value){
		$this->uri[$ns] = $value;
		$ns1 = "xmlns:".$ns;
		$ns2 = "XMLNS:".$ns;
		$num = $this->id_num;
		for($i=0;$i<$num;$i++){
			if($this->node[$i][1] != "0text"){
				$a_num = $this->node[$i][8];
				for($j=0;$j<$a_num;$j++){
					$name = $this->node[$i][9][$j];
					if(($name == $ns1)||($name == $ns2)){
						$this->node[$i][10][$j] = $value;
					}
				}
			}
		}	
	}
	
	function copy_node($id){
		if((!is_int($id)&&($id == ""))||($id<0)||($id>=$this->id_num)){
			die("<br>顼<br>copy_node:Ρֹ椬۾Ǥid=$id");
		}
		$child_array = array();
		$new_array = array();
		
		$this->mess = "";
		$level=0;
		$child_end = false;
		$child_array["child_id"][0] = $id;
		$child_array["child_index"][0] = 0;
		$new_parent = $this->node[$id][2];

		while(1){
			$id = $child_array["child_id"][$level];				//childe_arrayid
			if($child_end){										//nodeνλ
				$child_end = false;
				if($level == 0){								//ʬ롼Ȥξ礳νλ
					break;
				}
				$new_parent = $new_array[$level-1];				//node
				$parent = $child_array["child_id"][$level-1];	//node
				$index = $child_array["child_index"][$level];	//ʬindex
				$num2 = $this->node[$parent][6];	//ʬƱ٥λnodeο
				$index++;										//ʬμλnodeindex
				if($index == $num2){							//ʬǸλnodeξ
					$level--;									//nodeΥ٥򸽥٥ˤ
					$child_end = true;							//nodeνλ
				}else{											//ޤλnode
					$id = $this->node[$parent][7][$index];		//	ʬμλnodeid		
					$child_array["child_id"][$level] = $id;		//	child_array˽񤭹
					$child_array["child_index"][$level] = $index;
				}
			}else{
				if($this->node[$id][5] == 1){			//Textnodeξ
					$text = $this->node[$id][4];		//Textnode
					$this->add_textnode($new_parent,$text);
				}else{										//nodeξ
					$name = $this->node[$id][1];			//node̾
					$ns = $this->node[$id][11];				//nodeΥ͡ॹڡ
					$new_id = $this->add_node ($new_parent,$name,"",$ns);
					$num_attrib = $this->node[$id][8];				//°ο
					$this->node[$new_id][8] = $num_attrib;
					for($k=0;$k<$num_attrib;$k++){					//°Υԡ
						$this->node[$new_id][9][$k] = $this->node[$id][9][$k];		//°̾
						$this->node[$new_id][10][$k] = $this->node[$id][10][$k];	//°
					}
					$new_array[$level] = $new_id;
				}
				$num = $this->node[$id][6];		//ʬλnodeο
				if($num != 0){							//node
					$level++;									//nodeΥ٥򸽥٥ˤ
					$child_array["child_id"][$level] = $this->node[$id][7][0];	//nodeƬid񤭹
					$child_array["child_index"][$level] = 0;
					$new_parent = $new_id;
				}else{											//node̵
					$parent = $child_array["child_id"][$level-1];	//nodeid
					$index = $child_array["child_index"][$level];	//ʬindex
					$num2 = $this->node[$parent][6];	//ʬƱ٥λnodeο
					$index++;									//ʬμλnodeindex
					if($index == $num2){						//ʬǸλnodeξ
						$level--;								//nodeΥ٥򸽥٥ˤ
						$child_end = true;						//nodeνλ
					}else{										//ޤλnode
						$id = $this->node[$parent][7][$index];	//	ʬμλnodeid
						$child_array["child_id"][$level] = $id;	//	child_array˽񤭹
						$child_array["child_index"][$level] = $index;
					}
				}
			}
		}

		$new_id = $new_array[0];
		return $new_id;
	}
	function write_attrib($id){
		if((!is_int($id)&&($id == ""))||($id<0)||($id>=$this->id_num)){
			die("<br>顼<br>write_attrib:Ρֹ椬۾Ǥid=$id");
		}
		$num = $this->node[$id][8];
		for($j=0;$j<$num;$j++){
			$name = $this->node[$id][9][$j];
			$value = $this->node[$id][10][$j];
			$this->mess .= " ${name}=\"${value}\"";
		}
	}
	function write_node_name($id,$level){
		if((!is_int($id)&&($id == ""))||($id<0)||($id>=$this->id_num)){
			die("<br>顼<br>write_node_name:Ρֹ椬۾Ǥid=$id");
		}
		$name = $this->node[$id][1];
		$ns = $this->node[$id][11];
		if($ns != ""){
			$name = $ns . ":" .$name;
		}
		for($i=0;$i<$level;$i++){
			$this->mess .= "\t";
		}
		$this->mess .= "<${name}";
		$this->write_attrib($id);
		$this->mess .= ">\r\n";
	}
	function write_node_close($id,$level){
		if((!is_int($id)&&($id == ""))||($id<0)||($id>=$this->id_num)){
			die("<br>顼<br>write_node_close:Ρֹ椬۾Ǥid=$id");
		}
		$name = $this->node[$id][1];
		$ns = $this->node[$id][11];
		if($ns != ""){
			$name = $ns . ":" .$name;
		}
		for($i=0;$i<$level;$i++){
			$this->mess .="\t";
		}
		$this->mess .= "</${name}>\r\n";
	}
	function write_node_value($id,$level){
		if((!is_int($id)&&($id == ""))||($id<0)||($id>=$this->id_num)){
			die("<br>顼<br>write_node_value:Ρֹ椬۾Ǥid=$id");
		}
		$value = $this->node[$id][4];
		$text_array = preg_split("/\n/",$value);
		$num = count($text_array);
		for($j=0;$j<$num;$j++){
			$value = $text_array[$j];
			if($value != ""){
				for($i=0;$i<$level;$i++){
					$this->mess .= "\t";
				}
				$this->mess .= "${value}\r\n";
			}
		}
	}
	function write_node_line($id,$level){
		if((!is_int($id)&&($id == ""))||($id<0)||($id>=$this->id_num)){
			die("<br>顼<br>write_node_line:Ρֹ椬۾Ǥid=$id");
		}
		$name = $this->node[$id][1];
		$ns = $this->node[$id][11];
		if($ns != ""){
			$name = $ns . ":" .$name;
		}
		for($i=0;$i<$level;$i++){
			$this->mess .= "\t";
		}
		$this->mess .= "<${name}";
		$this->write_attrib($id);
		$this->mess .= "/>\r\n";
	}
	function write_node_line2($id,$level){
		if((!is_int($id)&&($id == ""))||($id<0)||($id>=$this->id_num)){
			die("<br>顼<br>write_node_line2:Ρֹ椬۾Ǥid=$id");
		}
		$name = $this->node[$id][1];
		$ns = $this->node[$id][11];
		if($ns != ""){
			$name = $ns . ":" .$name;
		}
		for($i=0;$i<$level;$i++){
			$this->mess .= "\t";
		}
		$this->mess .= "<${name}";
		$this->write_attrib($id);
		$this->mess .= ">";
		$child = $this->node[$id][7][0];
		$value = $this->node[$child][4];
		if(preg_match("/\n/",$value)){
			$text_array = preg_split("/\n/",$value);
			$num = count($text_array);
			$this->mess .= "\r\n";
			for($j=0;$j<$num;$j++){
				$value = $text_array[$j];
				if($value != ""){
					for($i=0;$i<=$level;$i++){
						$this->mess .= "\t";
					}
					$this->mess .= "${value}\r\n";
				}
			}
			for($i=0;$i<$level;$i++){
				$this->mess .= "\t";
			}
			$this->mess .= "</${name}>\r\n";
		}else{
			$this->mess .= "${value}";
			$this->mess .= "</${name}>\r\n";
		}
	}
	function encode($id){
		if((!is_int($id)&&($id == ""))||($id<0)||($id>=$this->id_num)){
			die("<br>顼<br>encode:Ρֹ椬۾Ǥid=$id");
		}
		$child_array = array();
		
		$this->mess = "";
		$level=0;
		$child_end = false;
		$child_array["child_id"][0] = $id;
		$child_array["child_index"][0] = 0;

		while(1){
			$id = $child_array["child_id"][$level];				//childe_arrayid
			if($child_end){										//nodeνλ
				$child_end = false;
				$this->write_node_close($id,$level);		//	ʬΥĤ
				if($level == 0){								//ʬ롼Ȥξ礳νλ
					break;
				}
				$parent = $child_array["child_id"][$level-1];	//node
				$index = $child_array["child_index"][$level];	//ʬindex
				$num2 = $this->node[$parent][6];	//ʬƱ٥λnodeο
				$index++;										//ʬμλnodeindex
				if($index == $num2){							//ʬǸλnodeξ
					$level--;									//nodeΥ٥򸽥٥ˤ
					$child_end = true;							//nodeνλ
				}else{											//ޤλnode
					$id = $this->node[$parent][7][$index];		//	ʬμλnodeid		
					$child_array["child_id"][$level] = $id;		//	child_array˽񤭹
					$child_array["child_index"][$level] = $index;
				}
			}else{
				$num = $this->node[$id][6];		//ʬλnodeο
				if($num == 1){
					if($this->is_text($this->node[$id][7][0])){	//ҥΡɤƥȥΡɣĤξ
						$this->write_node_line2($id,$level);	//ʬΥ(name,value)ν񤭹
						$index = $child_array["child_index"][$level];	//ʬindex
						$parent = $child_array["child_id"][$level-1];	//nodeid
						$num2 = $this->node[$parent][6];	//ʬƱ٥λnodeο
						$index++;									//ʬμλnodeindex
						if($index == $num2){						//ʬǸλnodeξ
							$level--;								//nodeΥ٥򸽥٥ˤ
							$child_end = true;						//nodeνλ
						}else{										//ޤλnode
							$id = $this->node[$parent][7][$index];	//	ʬμλnodeid
							$child_array["child_id"][$level] = $id;	//	child_array˽񤭹
							$child_array["child_index"][$level] = $index;
						}
					}else{
						$this->write_node_name($id,$level);		//ʬΥν񤭹
						$level++;									//nodeΥ٥򸽥٥ˤ
						$child_array["child_id"][$level] = $this->node[$id][7][0];	//nodeƬid񤭹
						$child_array["child_index"][$level] = 0;
					}
				}else if($num != 0){							//node
					$this->write_node_name($id,$level);		//ʬΥν񤭹
					$level++;									//nodeΥ٥򸽥٥ˤ
					$child_array["child_id"][$level] = $this->node[$id][7][0];	//nodeƬid񤭹
					$child_array["child_index"][$level] = 0;
				}else{											//node̵
					if($this->node[$id][5] == 1){			//Textnodeξ
						$this->write_node_value($id,$level);
					}else{										//nodeξ
						$this->write_node_line($id,$level);		//ʬΥ(name,value)ν񤭹
					}
					$parent = $child_array["child_id"][$level-1];	//nodeid
					$index = $child_array["child_index"][$level];	//ʬindex
					$num2 = $this->node[$parent][6];	//ʬƱ٥λnodeο
					$index++;									//ʬμλnodeindex
					if($index == $num2){						//ʬǸλnodeξ
						$level--;								//nodeΥ٥򸽥٥ˤ
						$child_end = true;						//nodeνλ
					}else{										//ޤλnode
						$id = $this->node[$parent][7][$index];	//	ʬμλnodeid
						$child_array["child_id"][$level] = $id;	//	child_array˽񤭹
						$child_array["child_index"][$level] = $index;
					}
				}
			}
		}
		return $this->mess;
	}

	function write_node($id,$fp,$flg,$enc){
		if((!is_int($id)&&($id == ""))||($id<0)||($id>=$this->id_num)){
			die("<br>顼<br>write_node:Ρֹ椬۾Ǥid=$id");
		}
		$text = "";
		if($this->xml_block == ""){
				$text .= "<?xml version=\"1.0\" encoding=\"$enc\" ?>\n";
		}else{
			$text .= $this->xml_block;
		}
		if($flg == 1){
			$text .= $this->dtd_block;
			$text .= $this->pi_block;
		}
		$text = preg_replace("/\n/","\r\n",$text);
		$this->encode($id);
		$text .= $this->mess;
		$text = preg_replace("/\r\n/","\n",$text);
		if($fp != ""){
			fwrite($fp,$text);
		}
		return $text;
	}

//	*************************** SOAPѴؿϡ******************************************
	function get_encode($msg){
		$text = "";
		if(preg_match("/<\?xml/",$msg)){
			$pos = strpos($msg,">");
			$text = substr($msg,0,$pos);
			$text = strtolower($text);
			$pos = strpos($text,"encoding");
			if(!is_long($pos) && !$pos) {
				return "";
			}
			$text = substr($text,$pos);
			$pos = strpos($text,"\"");
			if(!is_long($pos) && !$pos) {
				$pos = strpos($text,"'");
			}
			if(!is_long($pos) && !$pos) {
				$this->soap_die("\n顼\nXML۾Ǥ");
			}
			$text = substr($text,$pos+1);
			$pos = strpos($text,"\"");
			if(!is_long($pos) && !$pos) {
				$pos = strpos($text,"'");
			}
			if(!is_long($pos) && !$pos) {
				$this->soap_die("\n顼\nXML۾Ǥ");
			}
			$text = substr($text,0,$pos);
			switch($text){
				case 'euc-jp':
					$text = "EUC-JP";
					break;
				case 'shift-jis':
					$text = "SJIS";
					break;
				case 'sjis':
					$text = "SJIS";
					break;
				default:
					$text = strtoupper($text);
			}

		}
		return $text;
	}
	function make_Envelope(){
		$this->root = $this->make_root("Envelope","","SOAP-ENV");
		$this->add_attrib($this->root,"xmlns:SOAP-ENV=\"http://schemas.xmlsoap.org/soap/envelope/\"");
		$this->add_attrib($this->root,"SOAP-ENV:encodingStyle=\"http://schemas.xmlsoap.org/soap/encoding/\"");
		$this->root_flg = 1;
		return $this->root;
	}
	function make_Header(){
		$id = $this->add_node($this->root,"Header","","SOAP-ENV");
		return $id;
	}
	function make_Body(){
		$id = $this->add_node($this->root,"Body","","SOAP-ENV");
		return $id;
	}
	function send_Message($DOMAIN,$path,$HOST,$port=80,$soapaction=""){
		$fp = fsockopen ($DOMAIN,$port, $errno, $errstr, 30);
		if (!$fp) {
			print"$errstr ($errno)<br />\n";
		} else {
			if(preg_match("/<\?xml/",$this->mess)){
				$enc = $this->get_encode($this->mess);
				if($enc != ""){
					$this->mess = mb_convert_encoding($this->mess, "UTF-8",$enc);
					$pos = strpos($this->mess,">");
					$this->mess = "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>" . substr($this->mess,$pos+1);
				}
			}else{
				$this->mess = "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>" . $this->mess;
				$this->mess = mb_convert_encoding($this->mess, "UTF-8", "EUC-JP");
			}
			fputs ($fp, "POST ".$path." HTTP/1.1\r\n");
			fputs ($fp, "HOST: ".$HOST."\r\n");
			fputs ($fp, "Content-Length: " . strlen( $this->mess ) ."\r\n");
			fputs ($fp, "Content-Type: text/xml\r\n");
			fputs ($fp, "Soapaction: \"$soapaction\"\r\n");
			fputs ($fp, "\r\n");
			fputs ($fp, $this->mess);
			return $fp;
		}
	}
	function get_message($fp){
		$flg = 0;
		$flg2 = 0;
		$msg = "";
		$head = "";
		$length = 0;
		while (!feof($fp)) {
			$tmp = fgets ($fp,2048);
			if(trim($tmp) == ""){
				if($flg != 1){
					break;
				}else {
					$head .= $tmp;
				}
			}else if(trim($tmp) != "0"){
				if(preg_match("/Content-Length:/i",$tmp)){
					$length = trim(preg_replace("/Content-Length:/","",$tmp));
				}
				if(preg_match("/1([0-9][0-9])/",$tmp)&&preg_match("/http/i",$tmp)) {
					$flg = 1;
				}
				if(preg_match("/2([0-9][0-9])/",$tmp)&&preg_match("/http/i",$tmp)) {
					$flg = 2;
				}
				if(preg_match("/Status: 5([0-9][0-9])/",$tmp)){
					$flg = 5;
				}
				if(preg_match("/Transfer-Encoding:/i",$tmp)&&preg_match("/chunked/i",$tmp)){
					$flg2 = 1;
				}
				$head .= $tmp;
			}
		}
		if($flg2 == 1){
			$length = trim(fgets ($fp,2048));
			$length = hexdec($length);
		}
//		$msg = fread($fp, $length);
		$len = 0;
		$read_len = $length;
		while($len < $length){
			$msg .= fread($fp, $read_len);
			$len = strlen($msg);
			$read_len = $length - $len;
//			if($read_len != 0){
//				$msg .= EOF;
//			}
		}

		fclose ($fp);
		//print "<pre>" . htmlspecialchars($head) . "</pre>"; 
		$enc = $this->get_encode($msg);
		if($enc == "") $enc="UTF-8";
		$msg = mb_convert_encoding($msg, "EUC-JP",$enc);
		$msg2 = preg_replace("/</","&lt;",$msg);
		$msg2 = preg_replace("/>/","&gt;",$msg2);
		//print "<pre>" . htmlspecialchars($msg) . "</pre>"; 
		if($flg != 2){
			$this->soap_die($msg);
		}
		return $msg;
	}
	function saver_get_message(){
		global $HTTP_RAW_POST_DATA;
//		$msg =$HTTP_RAW_POST_DATA;
		$msg = "";
		$fp = fopen("php://input","r");
   		 while (($buffer = fgets($fp, 4096)) !== false) {
			$msg .= $buffer;
		}
		fclose($fp);
		if (get_magic_quotes_gpc()) {
			$msg = stripslashes($msg);
		}
		$enc = $this->get_encode($msg);
		if($enc == "") $enc="UTF-8";
		$msg = mb_convert_encoding($msg, "EUC-JP",$enc);

// 'data.txt' 
		return $msg;
	}
	function get_body($msg){
		$this->saxparser($msg);
		$root = $this->get_root();
		$ns = $this->get_ns($root);
		$uri = $this->get_uri($ns,$root);

		if($uri != "http://schemas.xmlsoap.org/soap/envelope/"){
			$this>soap_die("\n顼\nget_body:͡ॹڡ㤤ޤuri=$uri");
		}

		$body = $this->get_singlenode_r($root,"Body");

		$node_array = $this->get_childs($body);
		$id = $node_array[0];
		$fault = $this->get_node_name($id);
		$pos = strpos($fault,":");
		if($pos != 0){
			$fault = substr($fault,$pos+1);
		}
		if(preg_match("/Fault/i",$fault)){
			$this->soap_die($msg);
		}
		return $body;
	}
	function get_function($body){
		$node_array = $this->get_childs($body);
		$id = $node_array[0];
		$function = $this->get_node_name($id);
		$pos = strpos($function,":");
		if($pos != 0){
			$function = substr($function,$pos+1);
		}
		return $function;
	}
	function get_param($body){
		$node_array = $this->get_childs($body);
		$id = $node_array[0];
		$node_array = $this->get_childs($id);
		$num = count($node_array);
		$param = array();
		for($i=0;$i<$num;$i++){
			$id = $node_array[$i];
			$name = $this->get_node_name($id);
			$value = $this->get_value($id);
			$type = $this->get_attrib($id,"xsi:type");
			if($type == "SOAP-ENC:base64"){
				$value = base64_decode ($value);
				$enc2 = i18n_discover_encoding($value);
				if($enc2 == "unknown"){
					$enc2 = $this->enc;
				}else{
					$this->enc = $enc2;
				}
				$value = mb_convert_encoding($value, "EUC-JP",$enc2);
			}
			$param["name"][$i] = $name;
			$param["value"][$i] = $value;
		}
		return $param;
	}
	function get_enc(){
		return $this->enc;
	}
	function set_enc($enc2){
		$this->enc = $enc2;
	}
	function make_form(){
		$this->make_Envelope();
		$head = $this->make_Header();
		$body = $this->make_Body();
		return $body;
	}
	function sever_return_message(){
		$this->encode($this->root,0);
		$this->mess = "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>" . $this->mess;
		$this->mess = mb_convert_encoding($this->mess, "UTF-8", "EUC-JP");

		$len = strlen($this->mess);
		header("Content-Length: $len");
		header("Content-Type: text/xml");
		print $this->mess;
	}
	function response($param,$function,$ns,$uri){
		$this->make_Envelope();
		$head = $this->make_Header();
		$body = $this->make_Body();
		if($ns != ""){
			$id = $this->add_node($body,"${function}Response","xmlns:$ns=\"$uri\"","$ns");
		}else if($uri != ""){
			$id = $this->add_node($body,"${function}Response","xmlns=\"$uri\"","");
		}else{
			$id = $this->add_node($body,"${function}Response","","");
		}
		foreach ($param as $key => $val){
//		while(list($key,$val)=each($param)){
			$id2 = $this->add_node($id,$key,"","");
			$this->set_value($id2,$val);
		}
		$this->encode($this->root,0);
		$this->mess = "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>" . $this->mess;
		$this->mess = mb_convert_encoding($this->mess, "UTF-8", "EUC-JP");

		$len = strlen($this->mess);
		header("Content-Length: $len");
		header("Content-Type: text/xml");
		print $this->mess;
	}
	function response_type($param,$function,$ns,$uri){
		$this->make_Envelope();
		$this->add_attrib($this->root,"xmlns:xsi=\"http://www.w3.org/1999/XMLSchema-instance\"");
		$this->add_attrib($this->root,"xmlns:xsd=\"http://www.w3.org/1999/XMLSchema\"");
		$this->add_attrib($this->root,"xmlns:SOAP-ENC=\"http://schemas.xmlsoap.org/soap/encoding/\"");
		$head = $this->make_Header();
		$body = $this->make_Body();
		if($ns != ""){
			$id = $this->add_node($body,"${function}Response","xmlns:$ns=\"$uri\"","$ns");
		}else if($uri != ""){
			$id = $this->add_node($body,"${function}Response","xmlns=\"$uri\"","");
		}else{
			$id = $this->add_node($body,"${function}Response","","");
		}
		if(isset($param["value"])){
			$num = count($param["value"]);
		}else{
			$num=0;
		}
		for($i=0;$i<$num;$i++){
			$name = $param["name"][$i];
			$value = $param["value"][$i];
			$type = $param["type"][$i];
			if($type == "SOAP-ENC:base64"){
				$value = mb_convert_encoding($value,$this->enc, "EUC-JP");
				$value = base64_encode ($value);
				$id2 = $this->add_node($id,$name,"xsi:type=\"SOAP-ENC:base64\"","");
			}else{
				$id2 = $this->add_node($id,$name,"xsi:type=\"xsd:$type\"","");
			}
			$this->set_value($id2,$value);
		}
		$this->encode($this->root,0);

		$this->mess = "<?xml version=\"1.0\" encoding=\"UTF-8\" ?>" . $this->mess;
		$this->mess = mb_convert_encoding($this->mess, "UTF-8", "EUC-JP");

		$len = strlen($this->mess);
		header("Content-Length: $len");
		header("Content-Type: text/xml");
		print $this->mess;
	}
//	*************************** SOAPѴؿλ******************************************
}
//  ***************************    ״ؿ ɲ        **********************************
	function dump_dom($dom){
		//print_r($dom->node);
		//$a = array_keys($dom->node);
		//print_r($a);
		$end = $dom->id_num;
		$s = "<?php\n";
		$s .= "function reverse_dom(&\$dom){\n";
		$s .= "\$dom->root_flg = $dom->root_flg;\n";
		$s .= "\$dom->comment_block = '$dom->comment_block';\n";
		$s .= "\$dom->pi_block = '$dom->pi_block';\n";
		$s .= "\$dom->xml_block = '$dom->xml_block';\n";
		$s .= "\$dom->dtd_block = '$dom->dtd_block';\n";
		$s .= "\$dom->id_num = $end;\n";
		for($i=0;$i<$end;$i++){
			for($j=0;$j<=11;$j++){
				if($j==6){
					if(isset ($dom->node[$i][$j])){
						$child_num = $dom->node[$i][$j];
						$s .= "\$dom->node[$i][$j] = " . $dom->node[$i][$j] . ";\n";
					}else{
						$child_num = 0;
					}
				}else if($j == 7){
					for($k=0;$k<$child_num;$k++){
						$s .= "\$dom->node[$i][$j][$k] = " . $dom->node[$i][$j][$k] . ";\n";
					}
				}else if($j == 8){
					if(isset ($dom->node[$i][$j])){
						$attrib_num = $dom->node[$i][$j];
						$s .= "\$dom->node[$i][$j] = " . $dom->node[$i][$j] . ";\n";
					}else{
						$attrib_num = 0;
					}
				}else if(($j == 9) || ($j == 10)){
					for($k=0;$k<$attrib_num;$k++){
						$s .= "\$dom->node[$i][$j][$k] = \"" . $dom->node[$i][$j][$k] . "\";\n";
					}
				}else{
					if(isset ($dom->node[$i][$j])){
						if(($j == 1)||($j == 4)||($j == 11)){
							$s .= "\$dom->node[$i][$j] = \"" . str_replace('"','\"',$dom->node[$i][$j]) . "\";\n";
						}else{
							$s .= "\$dom->node[$i][$j] = " . $dom->node[$i][$j] . ";\n";
						}
					}
				}
			}
		}
		//print_r($dom->uri);
		foreach ($dom->uri as $k => $v){
//		while (list($k,$v) = each($dom->uri)) {
			$s .= "\$dom->uri[\"$k\"] = \"$v\";\n";
		}

		//print_r($dom->ns_default);
		$a = array_keys($dom->ns_default);
		$end = end($a);
		for($i=0;$i<=$end;$i++){
			for($j=0;$j<=2;$j++){
				if(isset ($dom->ns_default[$i][$j])){
					$s .= "\$dom->ns_default[$i][$j] = \"" . $dom->ns_default[$i][$j] . "\";\n";
				}
			}
		}
		$s .= "}\n";
		$s .= "?>\n";

		//print "<pre>";
		//print $s;
		//print "</pre>";
	
		return $s;
	}

//  ***************************    ״ؿ λ        **********************************
?>
